#include "Util.h"
#include <random>

// Some support code for random number generation and statistics reporting.
// Please ignore parts of it that you are not familiar with.

int n_comparisons_ = 0;
int n_swaps_ = 0;

std::minstd_rand MakeRng() {
  std::minstd_rand rng;
  rng.seed(std::random_device{}());
  return rng;
}

// This code is for generating random numbers and vectors
int32_t RandomInt() {
  static std::minstd_rand rng = MakeRng();
  return rng();
}

// Static functions for bookkeeping
void ReportStats() {
  std::cout << "# swaps:       ";
  std::cout.width(10);
  std::cout << std::right << n_swaps_ << "\n";
  std::cout << "# comparisons: ";
  std::cout.width(10);
  std::cout << std::right << n_comparisons_ << "\n";
  std::cout << "total ops:     ";
  std::cout.width(10);
  std::cout << std::right << n_swaps_ + n_comparisons_ << "\n";
}

void ResetStats() {
  n_swaps_ = 0;
  n_comparisons_ = 0;
}
